Index: /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.WinFormsUI/2.3.1/WinFormsUI-2.3.1/Docking/DockPanel.DockDragHandler.cs
===================================================================
--- /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.WinFormsUI/2.3.1/WinFormsUI-2.3.1/Docking/DockPanel.DockDragHandler.cs	(revision 4067)
+++ /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.WinFormsUI/2.3.1/WinFormsUI-2.3.1/Docking/DockPanel.DockDragHandler.cs	(revision 4068)
@@ -444,371 +377,311 @@
 							new Point(PaneDiamond.Left, PaneDiamond.Bottom)
 						};
-                            using (Matrix matrix = new Matrix(PaneDiamond.ClientRectangle, pts))
-                            {
-                                graphicsPath.Transform(matrix);
-                            }
-                            region.Union(graphicsPath);
-                        }
-                    }
-                    else
-                        PaneDiamond.Visible = false;
-
-                    Region = region;
-                }
-
-                private bool ShouldPanelIndicatorVisible(DockState dockState)
-                {
-                    if (!Visible)
-                        return false;
-
-                    if (DockPanel.DockWindows[dockState].Visible)
-                        return false;
-
-                    return DragHandler.DragSource.IsDockStateValid(dockState);
-                }
-
-                private bool ShouldPaneDiamondVisible()
-                {
-                    if (DockPane == null)
-                        return false;
-
-                    if (!DockPanel.AllowEndUserNestedDocking)
-                        return false;
-
-                    return DragHandler.DragSource.CanDockTo(DockPane);
-                }
-
-                public override void Show(bool bActivate)
-                {
-                    base.Show(bActivate);
-                    Bounds = SystemInformation.VirtualScreen;
-                    RefreshChanges();
-                }
-
-                public void TestDrop()
-                {
-                    Point pt = Control.MousePosition;
-                    DockPane = DockHelper.PaneAtPoint(pt, DockPanel);
-
-                    if (TestDrop(PanelLeft, pt) != DockStyle.None)
-                        HitTestResult = PanelLeft;
-                    else if (TestDrop(PanelRight, pt) != DockStyle.None)
-                        HitTestResult = PanelRight;
-                    else if (TestDrop(PanelTop, pt) != DockStyle.None)
-                        HitTestResult = PanelTop;
-                    else if (TestDrop(PanelBottom, pt) != DockStyle.None)
-                        HitTestResult = PanelBottom;
-                    else if (TestDrop(PanelFill, pt) != DockStyle.None)
-                        HitTestResult = PanelFill;
-                    else if (TestDrop(PaneDiamond, pt) != DockStyle.None)
-                        HitTestResult = PaneDiamond;
-                    else
-                        HitTestResult = null;
-
-                    if (HitTestResult != null)
-                    {
-                        if (HitTestResult is PaneIndicator)
-                            DragHandler.Outline.Show(DockPane, HitTestResult.Status);
-                        else
-                            DragHandler.Outline.Show(DockPanel, HitTestResult.Status, FullPanelEdge);
-                    }
-                }
-
-                private static DockStyle TestDrop(IHitTest hitTest, Point pt)
-                {
-                    return hitTest.Status = hitTest.HitTest(pt);
-                }
-            }
-
-            private class DockOutline : DockOutlineBase
-            {
-                public DockOutline()
-                {
-                    m_dragForm = new DragForm();
-                    SetDragForm(Rectangle.Empty);
-                    DragForm.BackColor = SystemColors.ActiveCaption;
-                    DragForm.Opacity = 0.5;
-                    DragForm.Show(false);
-                }
-
-                DragForm m_dragForm;
-                private DragForm DragForm
-                {
-                    get { return m_dragForm; }
-                }
-
-                protected override void OnShow()
-                {
-                    CalculateRegion();
-                }
-
-                protected override void OnClose()
-                {
-                    DragForm.Close();
-                }
-
-                private void CalculateRegion()
-                {
-                    if (SameAsOldValue)
-                        return;
-
-                    if (!FloatWindowBounds.IsEmpty)
-                        SetOutline(FloatWindowBounds);
-                    else if (DockTo is DockPanel)
-                        SetOutline(DockTo as DockPanel, Dock, (ContentIndex != 0));
-                    else if (DockTo is DockPane)
-                        SetOutline(DockTo as DockPane, Dock, ContentIndex);
-                    else
-                        SetOutline();
-                }
-
-                private void SetOutline()
-                {
-                    SetDragForm(Rectangle.Empty);
-                }
-
-                private void SetOutline(Rectangle floatWindowBounds)
-                {
-                    SetDragForm(floatWindowBounds);
-                }
-
-                private void SetOutline(DockPanel dockPanel, DockStyle dock, bool fullPanelEdge)
-                {
-                    Rectangle rect = fullPanelEdge ? dockPanel.DockArea : dockPanel.DocumentWindowBounds;
-                    rect.Location = dockPanel.PointToScreen(rect.Location);
-                    if (dock == DockStyle.Top)
-                    {
-                        int height = dockPanel.GetDockWindowSize(DockState.DockTop);
-                        rect = new Rectangle(rect.X, rect.Y, rect.Width, height);
-                    }
-                    else if (dock == DockStyle.Bottom)
-                    {
-                        int height = dockPanel.GetDockWindowSize(DockState.DockBottom);
-                        rect = new Rectangle(rect.X, rect.Bottom - height, rect.Width, height);
-                    }
-                    else if (dock == DockStyle.Left)
-                    {
-                        int width = dockPanel.GetDockWindowSize(DockState.DockLeft);
-                        rect = new Rectangle(rect.X, rect.Y, width, rect.Height);
-                    }
-                    else if (dock == DockStyle.Right)
-                    {
-                        int width = dockPanel.GetDockWindowSize(DockState.DockRight);
-                        rect = new Rectangle(rect.Right - width, rect.Y, width, rect.Height);
-                    }
-                    else if (dock == DockStyle.Fill)
-                    {
-                        rect = dockPanel.DocumentWindowBounds;
-                        rect.Location = dockPanel.PointToScreen(rect.Location);
-                    }
-
-                    SetDragForm(rect);
-                }
-
-                private void SetOutline(DockPane pane, DockStyle dock, int contentIndex)
-                {
-                    if (dock != DockStyle.Fill)
-                    {
-                        Rectangle rect = pane.DisplayingRectangle;
-                        if (dock == DockStyle.Right)
-                            rect.X += rect.Width / 2;
-                        if (dock == DockStyle.Bottom)
-                            rect.Y += rect.Height / 2;
-                        if (dock == DockStyle.Left || dock == DockStyle.Right)
-                            rect.Width -= rect.Width / 2;
-                        if (dock == DockStyle.Top || dock == DockStyle.Bottom)
-                            rect.Height -= rect.Height / 2;
-                        rect.Location = pane.PointToScreen(rect.Location);
-
-                        SetDragForm(rect);
-                    }
-                    else if (contentIndex == -1)
-                    {
-                        Rectangle rect = pane.DisplayingRectangle;
-                        rect.Location = pane.PointToScreen(rect.Location);
-                        SetDragForm(rect);
-                    }
-                    else
-                    {
-                        using (GraphicsPath path = pane.TabStripControl.GetOutline(contentIndex))
-                        {
-                            RectangleF rectF = path.GetBounds();
-                            Rectangle rect = new Rectangle((int)rectF.X, (int)rectF.Y, (int)rectF.Width, (int)rectF.Height);
-                            using (Matrix matrix = new Matrix(rect, new Point[] { new Point(0, 0), new Point(rect.Width, 0), new Point(0, rect.Height) }))
-                            {
-                                path.Transform(matrix);
-                            }
-                            Region region = new Region(path);
-                            SetDragForm(rect, region);
-                        }
-                    }
-                }
-
-                private void SetDragForm(Rectangle rect)
-                {
-                    DragForm.Bounds = rect;
-                    if (rect == Rectangle.Empty)
-                        DragForm.Region = new Region(Rectangle.Empty);
-                    else if (DragForm.Region != null)
-                        DragForm.Region = null;
-                }
-
-                private void SetDragForm(Rectangle rect, Region region)
-                {
-                    DragForm.Bounds = rect;
-                    DragForm.Region = region;
-                }
-            }
-
-            public DockDragHandler(DockPanel panel)
-                : base(panel)
-            {
-            }
-
-            public new IDockDragSource DragSource
-            {
-                get { return base.DragSource as IDockDragSource; }
-                set { base.DragSource = value; }
-            }
-
-            private DockOutlineBase m_outline;
-            public DockOutlineBase Outline
-            {
-                get { return m_outline; }
-                private set { m_outline = value; }
-            }
-
-            private DockIndicator m_indicator;
-            private DockIndicator Indicator
-            {
-                get { return m_indicator; }
-                set { m_indicator = value; }
-            }
-
-            private Rectangle m_floatOutlineBounds;
-            private Rectangle FloatOutlineBounds
-            {
-                get { return m_floatOutlineBounds; }
-                set { m_floatOutlineBounds = value; }
-            }
-
-            public void BeginDrag(IDockDragSource dragSource)
-            {
-                DragSource = dragSource;
-
-                if (!BeginDrag())
-                {
-                    DragSource = null;
-                    return;
-                }
-
-                Outline = new DockOutline();
-                Indicator = new DockIndicator(this);
-                Indicator.Show(false);
-
-                FloatOutlineBounds = DragSource.BeginDrag(StartMousePosition);
-            }
-
-            protected override void OnDragging()
-            {
-                TestDrop();
-            }
-
-            protected override void OnEndDrag(bool abort)
-            {
-                DockPanel.SuspendLayout(true);
-
-                Outline.Close();
-                Indicator.Close();
-
-                EndDrag(abort);
-
-                // Queue a request to layout all children controls
-                DockPanel.PerformMdiClientLayout();
-
-                DockPanel.ResumeLayout(true, true);
-
-                DragSource = null;
-            }
-
-            private void TestDrop()
-            {
-                Outline.FlagTestDrop = false;
-
-                Indicator.FullPanelEdge = ((Control.ModifierKeys & Keys.Shift) != 0);
-
-                if ((Control.ModifierKeys & Keys.Control) == 0)
-                {
-                    Indicator.TestDrop();
-
-                    if (!Outline.FlagTestDrop)
-                    {
-                        DockPane pane = DockHelper.PaneAtPoint(Control.MousePosition, DockPanel);
-                        if (pane != null && DragSource.IsDockStateValid(pane.DockState))
-                            pane.TestDrop(DragSource, Outline);
-                    }
-
-                    if (!Outline.FlagTestDrop && DragSource.IsDockStateValid(DockState.Float))
-                    {
-                        FloatWindow floatWindow = DockHelper.FloatWindowAtPoint(Control.MousePosition, DockPanel);
-                        if (floatWindow != null)
-                            floatWindow.TestDrop(DragSource, Outline);
-                    }
-                }
-                else
-                    Indicator.DockPane = DockHelper.PaneAtPoint(Control.MousePosition, DockPanel);
-
-                if (!Outline.FlagTestDrop)
-                {
-                    if (DragSource.IsDockStateValid(DockState.Float))
-                    {
-                        Rectangle rect = FloatOutlineBounds;
-                        rect.Offset(Control.MousePosition.X - StartMousePosition.X, Control.MousePosition.Y - StartMousePosition.Y);
-                        Outline.Show(rect);
-                    }
-                }
-
-                if (!Outline.FlagTestDrop)
-                {
-                    Cursor.Current = Cursors.No;
-                    Outline.Show();
-                }
-                else
-                    Cursor.Current = DragControl.Cursor;
-            }
-
-            private void EndDrag(bool abort)
-            {
-                if (abort)
-                    return;
-
-                if (!Outline.FloatWindowBounds.IsEmpty)
-                    DragSource.FloatAt(Outline.FloatWindowBounds);
-                else if (Outline.DockTo is DockPane)
-                {
-                    DockPane pane = Outline.DockTo as DockPane;
-                    DragSource.DockTo(pane, Outline.Dock, Outline.ContentIndex);
-                }
-                else if (Outline.DockTo is DockPanel)
-                {
-                    DockPanel panel = Outline.DockTo as DockPanel;
-                    panel.UpdateDockWindowZOrder(Outline.Dock, Outline.FlagFullEdge);
-                    DragSource.DockTo(panel, Outline.Dock);
-                }
-            }
-        }
-
-        private DockDragHandler m_dockDragHandler = null;
-        private DockDragHandler GetDockDragHandler()
-        {
-            if (m_dockDragHandler == null)
-                m_dockDragHandler = new DockDragHandler(this);
-            return m_dockDragHandler;
-        }
-
-        internal void BeginDrag(IDockDragSource dragSource)
-        {
-            GetDockDragHandler().BeginDrag(dragSource);
-        }
+              using (Matrix matrix = new Matrix(PaneDiamond.ClientRectangle, pts)) {
+                graphicsPath.Transform(matrix);
+              }
+              region.Union(graphicsPath);
+            }
+          } else
+            PaneDiamond.Visible = false;
+
+          Region = region;
+        }
+
+        private bool ShouldPanelIndicatorVisible(DockState dockState) {
+          if (!Visible)
+            return false;
+
+          if (DockPanel.DockWindows[dockState].Visible)
+            return false;
+
+          return DragHandler.DragSource.IsDockStateValid(dockState);
+        }
+
+        private bool ShouldPaneDiamondVisible() {
+          if (DockPane == null)
+            return false;
+
+          if (!DockPanel.AllowEndUserNestedDocking)
+            return false;
+
+          return DragHandler.DragSource.CanDockTo(DockPane);
+        }
+
+        public override void Show(bool bActivate) {
+          base.Show(bActivate);
+          Bounds = SystemInformation.VirtualScreen;
+          RefreshChanges();
+        }
+
+        public void TestDrop() {
+          Point pt = Control.MousePosition;
+          DockPane = DockHelper.PaneAtPoint(pt, DockPanel);
+
+          if (TestDrop(PanelLeft, pt) != DockStyle.None)
+            HitTestResult = PanelLeft;
+          else if (TestDrop(PanelRight, pt) != DockStyle.None)
+            HitTestResult = PanelRight;
+          else if (TestDrop(PanelTop, pt) != DockStyle.None)
+            HitTestResult = PanelTop;
+          else if (TestDrop(PanelBottom, pt) != DockStyle.None)
+            HitTestResult = PanelBottom;
+          else if (TestDrop(PanelFill, pt) != DockStyle.None)
+            HitTestResult = PanelFill;
+          else if (TestDrop(PaneDiamond, pt) != DockStyle.None)
+            HitTestResult = PaneDiamond;
+          else
+            HitTestResult = null;
+
+          if (HitTestResult != null) {
+            if (HitTestResult is PaneIndicator)
+              DragHandler.Outline.Show(DockPane, HitTestResult.Status);
+            else
+              DragHandler.Outline.Show(DockPanel, HitTestResult.Status, FullPanelEdge);
+          }
+        }
+
+        private static DockStyle TestDrop(IHitTest hitTest, Point pt) {
+          return hitTest.Status = hitTest.HitTest(pt);
+        }
+      }
+
+      private class DockOutline : DockOutlineBase {
+        public DockOutline() {
+          m_dragForm = new DragForm();
+          SetDragForm(Rectangle.Empty);
+          DragForm.BackColor = SystemColors.ActiveCaption;
+          DragForm.Opacity = 0.5;
+          DragForm.Show(false);
+        }
+
+        DragForm m_dragForm;
+        private DragForm DragForm {
+          get { return m_dragForm; }
+        }
+
+        protected override void OnShow() {
+          CalculateRegion();
+        }
+
+        protected override void OnClose() {
+          DragForm.Close();
+        }
+
+        private void CalculateRegion() {
+          if (SameAsOldValue)
+            return;
+
+          if (!FloatWindowBounds.IsEmpty)
+            SetOutline(FloatWindowBounds);
+          else if (DockTo is DockPanel)
+            SetOutline(DockTo as DockPanel, Dock, (ContentIndex != 0));
+          else if (DockTo is DockPane)
+            SetOutline(DockTo as DockPane, Dock, ContentIndex);
+          else
+            SetOutline();
+        }
+
+        private void SetOutline() {
+          SetDragForm(Rectangle.Empty);
+        }
+
+        private void SetOutline(Rectangle floatWindowBounds) {
+          SetDragForm(floatWindowBounds);
+        }
+
+        private void SetOutline(DockPanel dockPanel, DockStyle dock, bool fullPanelEdge) {
+          Rectangle rect = fullPanelEdge ? dockPanel.DockArea : dockPanel.DocumentWindowBounds;
+          rect.Location = dockPanel.PointToScreen(rect.Location);
+          if (dock == DockStyle.Top) {
+            int height = dockPanel.GetDockWindowSize(DockState.DockTop);
+            rect = new Rectangle(rect.X, rect.Y, rect.Width, height);
+          } else if (dock == DockStyle.Bottom) {
+            int height = dockPanel.GetDockWindowSize(DockState.DockBottom);
+            rect = new Rectangle(rect.X, rect.Bottom - height, rect.Width, height);
+          } else if (dock == DockStyle.Left) {
+            int width = dockPanel.GetDockWindowSize(DockState.DockLeft);
+            rect = new Rectangle(rect.X, rect.Y, width, rect.Height);
+          } else if (dock == DockStyle.Right) {
+            int width = dockPanel.GetDockWindowSize(DockState.DockRight);
+            rect = new Rectangle(rect.Right - width, rect.Y, width, rect.Height);
+          } else if (dock == DockStyle.Fill) {
+            rect = dockPanel.DocumentWindowBounds;
+            rect.Location = dockPanel.PointToScreen(rect.Location);
+          }
+
+          SetDragForm(rect);
+        }
+
+        private void SetOutline(DockPane pane, DockStyle dock, int contentIndex) {
+          if (dock != DockStyle.Fill) {
+            Rectangle rect = pane.DisplayingRectangle;
+            if (dock == DockStyle.Right)
+              rect.X += rect.Width / 2;
+            if (dock == DockStyle.Bottom)
+              rect.Y += rect.Height / 2;
+            if (dock == DockStyle.Left || dock == DockStyle.Right)
+              rect.Width -= rect.Width / 2;
+            if (dock == DockStyle.Top || dock == DockStyle.Bottom)
+              rect.Height -= rect.Height / 2;
+            rect.Location = pane.PointToScreen(rect.Location);
+
+            SetDragForm(rect);
+          } else if (contentIndex == -1) {
+            Rectangle rect = pane.DisplayingRectangle;
+            rect.Location = pane.PointToScreen(rect.Location);
+            SetDragForm(rect);
+          } else {
+            using (GraphicsPath path = pane.TabStripControl.GetOutline(contentIndex)) {
+              RectangleF rectF = path.GetBounds();
+              Rectangle rect = new Rectangle((int)rectF.X, (int)rectF.Y, (int)rectF.Width, (int)rectF.Height);
+              using (Matrix matrix = new Matrix(rect, new Point[] { new Point(0, 0), new Point(rect.Width, 0), new Point(0, rect.Height) })) {
+                path.Transform(matrix);
+              }
+              Region region = new Region(path);
+              SetDragForm(rect, region);
+            }
+          }
+        }
+
+        private void SetDragForm(Rectangle rect) {
+          DragForm.Bounds = rect;
+          if (rect == Rectangle.Empty)
+            DragForm.Region = new Region(Rectangle.Empty);
+          else if (DragForm.Region != null)
+            DragForm.Region = null;
+        }
+
+        private void SetDragForm(Rectangle rect, Region region) {
+          DragForm.Bounds = rect;
+          DragForm.Region = region;
+        }
+      }
+
+      public DockDragHandler(DockPanel panel)
+        : base(panel) {
+      }
+
+      public new IDockDragSource DragSource {
+        get { return base.DragSource as IDockDragSource; }
+        set { base.DragSource = value; }
+      }
+
+      private DockOutlineBase m_outline;
+      public DockOutlineBase Outline {
+        get { return m_outline; }
+        private set { m_outline = value; }
+      }
+
+      private DockIndicator m_indicator;
+      private DockIndicator Indicator {
+        get { return m_indicator; }
+        set { m_indicator = value; }
+      }
+
+      private Rectangle m_floatOutlineBounds;
+      private Rectangle FloatOutlineBounds {
+        get { return m_floatOutlineBounds; }
+        set { m_floatOutlineBounds = value; }
+      }
+
+      public void BeginDrag(IDockDragSource dragSource) {
+        DragSource = dragSource;
+
+        if (!BeginDrag()) {
+          DragSource = null;
+          return;
+        }
+
+        Outline = new DockOutline();
+        Indicator = new DockIndicator(this);
+        Indicator.Show(false);
+
+        FloatOutlineBounds = DragSource.BeginDrag(StartMousePosition);
+      }
+
+      protected override void OnDragging() {
+        TestDrop();
+      }
+
+      protected override void OnEndDrag(bool abort) {
+        DockPanel.SuspendLayout(true);
+
+        Outline.Close();
+        Indicator.Close();
+
+        EndDrag(abort);
+
+        // Queue a request to layout all children controls
+        DockPanel.PerformMdiClientLayout();
+
+        DockPanel.ResumeLayout(true, true);
+
+        DragSource = null;
+      }
+
+      private void TestDrop() {
+        Outline.FlagTestDrop = false;
+
+        Indicator.FullPanelEdge = ((Control.ModifierKeys & Keys.Shift) != 0);
+
+        if ((Control.ModifierKeys & Keys.Control) == 0) {
+          Indicator.TestDrop();
+
+          if (!Outline.FlagTestDrop) {
+            DockPane pane = DockHelper.PaneAtPoint(Control.MousePosition, DockPanel);
+            if (pane != null && DragSource.IsDockStateValid(pane.DockState))
+              pane.TestDrop(DragSource, Outline);
+          }
+
+          if (!Outline.FlagTestDrop && DragSource.IsDockStateValid(DockState.Float)) {
+            FloatWindow floatWindow = DockHelper.FloatWindowAtPoint(Control.MousePosition, DockPanel);
+            if (floatWindow != null)
+              floatWindow.TestDrop(DragSource, Outline);
+          }
+        } else
+          Indicator.DockPane = DockHelper.PaneAtPoint(Control.MousePosition, DockPanel);
+
+        if (!Outline.FlagTestDrop) {
+          if (DragSource.IsDockStateValid(DockState.Float)) {
+            Rectangle rect = FloatOutlineBounds;
+            rect.Offset(Control.MousePosition.X - StartMousePosition.X, Control.MousePosition.Y - StartMousePosition.Y);
+            Outline.Show(rect);
+          }
+        }
+
+        if (!Outline.FlagTestDrop) {
+          Cursor.Current = Cursors.No;
+          Outline.Show();
+        } else
+          Cursor.Current = DragControl.Cursor;
+      }
+
+      private void EndDrag(bool abort) {
+        if (abort)
+          return;
+
+        if (!Outline.FloatWindowBounds.IsEmpty)
+          DragSource.FloatAt(Outline.FloatWindowBounds);
+        else if (Outline.DockTo is DockPane) {
+          DockPane pane = Outline.DockTo as DockPane;
+          DragSource.DockTo(pane, Outline.Dock, Outline.ContentIndex);
+        } else if (Outline.DockTo is DockPanel) {
+          DockPanel panel = Outline.DockTo as DockPanel;
+          panel.UpdateDockWindowZOrder(Outline.Dock, Outline.FlagFullEdge);
+          DragSource.DockTo(panel, Outline.Dock);
+        }
+      }
     }
+
+    private DockDragHandler m_dockDragHandler = null;
+    private DockDragHandler GetDockDragHandler() {
+      if (m_dockDragHandler == null)
+        m_dockDragHandler = new DockDragHandler(this);
+      return m_dockDragHandler;
+    }
+
+    internal void BeginDrag(IDockDragSource dragSource) {
+      GetDockDragHandler().BeginDrag(dragSource);
+    }
+  }
 }
